<?php

namespace Treewec\FileSystem;

/**
 * Test class for FileFactory.
 * Generated by PHPUnit on 2012-03-25 at 16:40:23.
 * @group filesystem
 */
class FileFactoryTest extends \PHPUnit_Framework_TestCase {

    private $exceptionHelper;
    private $exceptionClass;
    private $callback;
    
    protected function setUp() {
        $this->exceptionClass = '\Treewec\Exceptions\ClientRequestException';
        $this->callback = array('\Treewec\FileSystem\FileFactory', 'build');
        $this->exceptionHelper = new \Treewec\ExceptionHelper();
    }

    public function testBuild() {
        $this->assertInstance('\Treewec\FileSystem\File', 'navigation');
        $this->assertInstance('\Treewec\FileSystem\Directory', 'teams/');
        $this->assertInstance('\Treewec\FileSystem\File', 'index', TREEWEC_ADMIN_ROOT . 'theme/');
        $this->assertInstance('\Treewec\FileSystem\Directory', 'utils/', TREEWEC_CLASS_ROOT);

        $this->exceptionHelper->catchExceptionInCallback($this->exceptionClass, $this->callback, __FILE__);
        $this->exceptionHelper->catchExceptionInCallback($this->exceptionClass, $this->callback, __DIR__);
    }

    private function assertInstance($class, $path, $rootDir = TREEWEC_VIEW_DIR) {
        if ($rootDir == TREEWEC_VIEW_DIR) {
            parent::assertInstanceOf($class, FileFactory::build($path));
        }
        parent::assertInstanceOf($class, FileFactory::build($path, $rootDir));
    }
    
}

?>
